#MenuTitle: Compare Sets
# -*- coding: utf-8 -*-
__doc__="""
Shows diffrences between glyph sets and allows to add glyphs to fonts.
"""

from GlyphsApp import *
from vanilla import *


font1 = Glyphs.fonts[0]
font2 = Glyphs.fonts[1]
masterName1 = font1.masters[0].name
masterName2 = font2.masters[0].name

#Crete list with all glyphs
lista1 = []
lista2 = []
for a in font1.glyphs:
	b = str(a).split('"')
	lista1.append(b[1])
for a in font2.glyphs:
	b = str(a).split('"')
	lista2.append(b[1])
#Make sets of lists
font1Set = set(lista1)
font2Set = set(lista2)
#Make sets with differences
OneDiff = font1Set.difference(font2Set)
TwoDiff = font2Set.difference(font1Set)
#Transform sets to list again
OneDiffList = list(OneDiff)
TwoDiffList = list(TwoDiff)
	
class ListDemo(object):
  
	def __init__(self):
		self.w = Window((320, 300))
		
		self.w.textBox = TextBox((10, 10, -10, 34), "Only on \n" + font1.familyName + " " + masterName1)
		self.w.myList = List((10, 55, 140, -40), OneDiffList)
		self.w.button = Button((10, -30, 140, 20), "Add to font",
							callback=self.button1Callback)
					 
		self.w.textBox2 = TextBox((170, 10, -10, 34), "Only on \n" + font2.familyName + " " + masterName2)                     
		self.w.myList2 = List((170, 55, 140, -40), TwoDiffList)
		self.w.button2 = Button((170, -30, 140, 20), "Add to font",callback=self.button2Callback1)          
		self.w.open()
		
	def button1Callback(self, sender):
		seleccion = self.w.myList.getSelection()
		for i in seleccion:
			name = self.w.myList[i]
			print name
			font2.glyphs.append(GSGlyph(name))

	def button2Callback1(self, sender):
		seleccion = self.w.myList2.getSelection()
		print seleccion
		for i in seleccion:
			print i
			name = self.w.myList2[i]
			print name
			font1.glyphs.append(GSGlyph(name))
			
	

ListDemo()